#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include <Arduino.h>

typedef enum eSystem_Status
{
  sysStat_Startup,
  sysStat_Normal,
  sysStat_Error,
  sysStat_Shutdown
} tSystem_Status;

typedef enum eEERequest
{
  EE_IDLE,
  EE_CFG_SAVE,
  EE_CFG_LOAD,
  EE_PDS_SAVE,
  EE_PDS_LOAD
} tEERequest;

typedef struct Globals_s
{
  char DeviceName[33];
  char DeviceName_ID[43];
  tSystem_Status systemStatus = sysStat_Startup;
  tSystem_Status resumeStatus = sysStat_Startup;
  eEERequest requestEEAction = EE_IDLE;
  float loadvoltage = 0;
  int battery_level = 0;
} Globals_t;

extern Globals_t globals;

#endif